unit EcclysiarchMain;

interface

uses
  {$IFDEF MSWINDOWS}
  Windows, FMX.Platform.Win,
  {$ENDIF}
  Types, UITypes, Classes, Variants, ImageList, Xml.XmlIntf,
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Gestures,
  FMX.TabControl, FMX.Forms, FMX.Dialogs, FMX.StdCtrls,
  FMX.ScrollBox, FMX.Memo, FMX.Layouts,
  FMX.TreeView, FMX.ImgList, FMX.ListBox, FMX.Edit, FMX.EditBox,
  FMX.SpinBox, FMX.MultiView, FMX.Controls.Presentation, FMX.Objects,
  FMX.Menus, FMX.WebBrowser, EccReqst;

type
  TEccMainForm = class(TForm)
    TabControl1, TabControl2: TTabControl;
    TabItem1, TabItem2, TabItem3, TabItem4, TabItem5, TabItem6: TTabItem;
    VertScrollBox2, VertScrollBox3: TVertScrollBox;
    Expander1, Expander2: TExpander;
    CheckBox1, CheckBox2, CheckBox3, CheckBox4, CheckBox5,
      CheckBox6, CheckBox7, CheckBox8, CheckBox9, CheckBox10,
      CheckBox11, CheckBox14, CheckBox15: TCheckBox;
    TreeView1: TTreeView;
    ImageList1: TImageList;
    CheckBox13: TCheckBox;
    CheckBox16: TCheckBox;
    Panel2: TPanel;
    SpinBox1: TSpinBox;
    ComboBox1: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ComboBox2: TComboBox;
    Expander3: TExpander;
    Expander4: TExpander;
    Expander5: TExpander;
    Expander6: TExpander;
    CheckBox17: TCheckBox;
    Panel4: TPanel;
    VertScrollBox1: TVertScrollBox;
    Memo1: TMemo;
    Image1: TImage;
    PopupMenu1: TPopupMenu;
    MultiView1: TMultiView;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    Expander7: TExpander;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    StyleBook_Amakrits: TStyleBook;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    HeaderToolBar: TToolBar;
    MasterButton: TSpeedButton;
    SpeedButton1: TSpeedButton;
    ToolBarLabel: TLabel;
    SpeedButton2: TSpeedButton;
    MenuItem11: TMenuItem;
    Expander8: TExpander;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox30: TCheckBox;
    CheckBox31: TCheckBox;
    CheckBox32: TCheckBox;
    CheckBox33: TCheckBox;
    CheckBox34: TCheckBox;
    CheckBox36: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    CheckBox12: TCheckBox;
    CheckBox35: TCheckBox;
    CheckBox37: TCheckBox;
    GestureManager1: TGestureManager;
    Label1: TLabel;
    ReqFrame: TReqFrame;
    Expander9: TExpander;
    Expander10: TExpander;
    CheckBox40: TCheckBox;
    CheckBox42: TCheckBox;
    CheckBox39: TCheckBox;
    procedure SysCheckBoxChange(Sender: TObject);
    procedure TreeView1Change(Sender: TObject);
    procedure CalendarChange(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure SpinBox1Change(Sender: TObject);
    procedure MultiView1Hidden(Sender: TObject);
    procedure MasterButtonClick(Sender: TObject);
    procedure MasterButtonTap(Sender: TObject; const Point: TPointF);
    procedure MasterButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure CBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure CBTap(Sender: TObject; const Point: TPointF);
    procedure CBGesture(Sender: TObject;
      const EventInfo: TGestureEventInfo; var Handled: Boolean);
    procedure RankMenuItemClick(Sender: TObject);
    procedure RankMenuItemTap(Sender: TObject; const Point: TPointF);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton1Tap(Sender: TObject; const Point: TPointF);
    procedure ToolBarLabelDblClick(Sender: TObject);
    procedure ToolBarLabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton2Tap(Sender: TObject; const Point: TPointF);
    procedure Expander4Resized(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ExpandedChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    WebBrowser1: TWebBrowser;
    procedure SelectMemory(Sender: TObject);
    procedure Switch;
  private
    AnchorGo: Integer;
    procedure BrowserShow;
    procedure AssignControls;
    procedure InitControlsArrays;
    procedure LoadAdminTree;
    procedure AddBlockIndex(const Name: string; Level, Id: Integer);
    procedure BlockIndexClick(Sender: TObject);
    procedure BlockIndexTap(Sender: TObject; const Point: TPointF);
    procedure OpenRankPopup(Sender: TObject; X, Y: Single);
    function CreatePath: string;
    procedure UncheckRequest(Sender: TObject);
    procedure SelectPath(const P: string);
    property Path: string read CreatePath write SelectPath;
  end;

var
  EccMainForm: TEccMainForm;
  WeekLab: array[1..7] of TLabel;
  _OptionsChanged: Boolean;
  CalendButtons: array[1..42] of TSpeedButton;
  Expds: array[1..5] of TExpander;
  NDate: TDateTime;

implementation

{$R *.fmx}

uses
  Xml.XmlDoc, DateUtils, Generics.Collections,
  SysUtils, StrUtils,
  EccDefs, EccProcs, EccCSlav, EccXml, EccHtml, EccScripts,
  EccCalend, EccAdmin, EccMemos, EccLists, EccVars, EccPrays;

var
  CurrentChanging: TMemory;
  AResult: Integer;

procedure AdjustPlaceVars(TVNode: TTreeViewItem);
var
  n: TTreeViewItem;
  a: TAdminNode;
  pl: TList<TPerson>;
  m4: string;
  p0: Integer;
begin
  n := TVNode;
  a := TAdminNode(n.TagObject);
  p0 := a.Parent.CongrType;
  Vars.AddOrSetValue('Hram.IsGrad', Ord(p0 = 0).ToString);
  Vars.AddOrSetValue('Hram.IsObitel', Ord(p0 = 2).ToString);
  Vars.AddOrSetValue('Hram.NastoyatName', TAdminNode(n.Parent).NastName);
  ServMap[9].Id := a.ServiceId;
  ServMap[9].GloryId := a.GloryId;
  pl := TList<TPerson>.Create;
  p0 := 0;
  repeat
    if (a.NodeType < 2) and (a.FPerson > 0) and
    (a.FPerson <> p0) then
      begin
        pl.Insert(0, a.Person);
        p0 := a.FPerson;
      end;
    if n.ParentItem <> nil then n := TTreeViewItem(n.ParentItem)
    else Break;
    a := TAdminNode(n.TagObject);
  until False;
  PravArhierey := pl.Last;
  for p0 := 0 to pl.Count - 1 do
    m4 := m4 + '-' + pl[p0].Id.ToString + ', ';
  m4 := m4.Substring(0, m4.Length - 2);
  Vars.AddOrSetValue('Hram.IerarhList', m4);
  Vars.AddOrSetValue(SysVars[16], EccMainForm.Path);
  pl.Free;
  ProcessChild(ProcDic.Items['hram_init'], _notParam, PrayList);
end;

function TEccMainForm.CreatePath: string;
var
  ti: TTreeViewItem;
begin
  Result := '';
  ti := TreeView1.Selected;
  repeat
    Result := TAdminNode(ti.TagObject).Id.ToString + '.' + Result;
    ti := ti.ParentItem;
  until ti = nil;
  Result := Result.Remove(Result.Length - 1);
end;

procedure TEccMainForm.SelectPath(const P: string);
var
  ti: TFmxObject;
  o: TTreeViewItem;
  i, j, k: Integer;
  s1, s2: string;
begin
  ti := TreeView1;
  s2 := P;
  repeat
    StrDivide(s2, s1, s2, '.');
    i := ToInt(s1);
    if ti.ClassType = TTreeView then k := TTreeView(ti).Count
    else k := TTreeViewItem(ti).Count;
    for j := 0 to k do
      begin
        if ti.ClassType = TTreeView then o := TTreeView(ti).Items[j]
        else o := TTreeViewItem(ti)[j];
        if TAdminNode(o.TagObject).Id = i then
          begin
            ti := o;
            o.Expand;
            Break;
          end;
      end;
  until s2 = '';
  if ti <> TreeView1 then o.Select;
end;

procedure Request(const Node: IXmlNode; const s: string);
const
  _t: array[0..1] of string = ('text', 'ctrl');
begin
  with EccMainForm, ReqFrame, Node.ChildNodes do
    try
      Prepare(s, GetNumAttr(Node, 'save') <> 0);
      for var i := 0 to Count - 1 do
        case IndexStr(Nodes[i].NodeName, _t) of
          0: AddText(Nodes[i].Text);
          1: case IndexStr(GetAttr(Nodes[i], 'type'), ['sel', 'flag']) of
               0: AddRadioGroup(GetAttr(Nodes[i], _t[0]), GetAttr(Nodes[i], 'id'), GetNumAttr(Nodes[i], 'default'));
               1: AddCheckBox(GetAttr(Nodes[i], _t[0]), GetAttr(Nodes[i], 'id'), GetNumAttr(Nodes[i], 'default') <> 0);
             end;
          else begin
            {$IFDEF DEBUG}
            OutMessage('   : ' + Nodes[i].NodeName);
            raise Exception.Create('');
            {$ENDIF}
          end;
        end;
      EccMainForm.ReqFrame.ShowModal;
    except
      {$IFDEF DEBUG}
      OutMessage('  :'#13#10 + s);
      {$ENDIF}
    end;
end;

procedure TEccMainForm.AssignControls;
var
  sl: TStringList;
  ch: TCheckBox;
begin
  try
    CheckBox1.IsChecked := BoolVar(SysVars[0]);
    CheckBox2.IsChecked := BoolVar(SysVars[1]);
    CheckBox3.IsChecked := BoolVar(SysVars[2]);
    CheckBox4.IsChecked := BoolVar(SysVars[3]);
    CheckBox5.IsChecked := BoolVar(SysVars[4]);
    CheckBox7.IsChecked := BoolVar(SysVars[6]);
    CheckBox6.IsChecked := BoolVar(SysVars[5]);
    CheckBox8.IsChecked := BoolVar(SysVars[7]);
    CheckBox9.IsChecked := BoolVar(SysVars[8]);
    CheckBox16.IsChecked := BoolVar(SysVars[9]);
    CheckBox17.IsChecked := BoolVar(SysVars[10]);
    RadioButton1.IsChecked := (Vars[SysVars[11]] = '0');
    RadioButton2.IsChecked := (Vars[SysVars[11]] = '1');
    RadioButton3.IsChecked := (Vars[SysVars[11]] = '2');
    RadioButton4.IsChecked := (Vars[SysVars[11]] = '3');
    RadioButton5.IsChecked := (Vars[SysVars[11]] = '4');
    RadioButton6.IsChecked := (Vars[SysVars[11]] = '5');
    CheckBox36.IsChecked := BoolVar(SysVars[12]);
    CheckBox13.IsChecked := BoolVar(SysVars[13]);
    CheckBox11.IsChecked := BoolVar(SysVars[14]);
    CheckBox10.IsChecked := BoolVar(SysVars[15]);
    CheckBox14.IsChecked := not BoolVar(SysVars[17]);
    CheckBox15.IsChecked := BoolVar(SysVars[18]);
    CheckBox18.IsChecked := BoolVar(SysVars[21]);
    CheckBox19.IsChecked := BoolVar(SysVars[22]);
    CheckBox20.IsChecked := BoolVar(SysVars[23]);
    CheckBox21.IsChecked := BoolVar(SysVars[24]);
    CheckBox23.IsChecked := BoolVar(SysVars[25]);
    CheckBox27.IsChecked := BoolVar(SysVars[26]);
    CheckBox22.IsChecked := BoolVar(SysVars[27]);
    CheckBox25.IsChecked := BoolVar(SysVars[28]);
    CheckBox24.IsChecked := BoolVar(SysVars[29]);
    CheckBox26.IsChecked := BoolVar(SysVars[30]);
    CheckBox28.IsChecked := BoolVar(SysVars[31]);
    CheckBox29.IsChecked := BoolVar(SysVars[32]);
    CheckBox31.IsChecked := BoolVar(SysVars[33]);
    CheckBox30.IsChecked := BoolVar(SysVars[34]);
    CheckBox32.IsChecked := BoolVar(SysVars[35]);
    CheckBox33.IsChecked := BoolVar(SysVars[36]);
    CheckBox12.IsChecked := BoolVar(SysVars[37]);
    CheckBox34.IsChecked := BoolVar(SysVars[38]);
    CheckBox35.IsChecked := BoolVar(SysVars[39]);
    CheckBox37.IsChecked := BoolVar(SysVars[40]);
    CheckBox40.IsChecked := BoolVar(SysVars[41]);
    CheckBox42.IsChecked := BoolVar(SysVars[43]);
    CheckBox39.IsChecked := Vars[SysVars[42]] <> '';
    sl := TStringList.Create;
    sl.Duplicates := dupIgnore;
    for var s: string in RqVars.Values do sl.Add(s);
    for var i := 0 to sl.Count - 1 do
      begin
        ch := TCheckBox.Create(EccMainForm);
        ch.Text := sl[i];
        ch.IsChecked := True;
        ch.Position.Y := 1000;
        ch.Align := TAlignLayout.Top;
        ch.Margins.Left := 8;
        if i = 0 then ch.Margins.Top := 6;
        ch.Height := 23;
        ch.OnChange := UncheckRequest;
        Expander9.AddObject(ch);
      end;
    ExpandedChanged(Expander9);
  except
  end;
end;

procedure TEccMainForm.SysCheckBoxChange(Sender: TObject);
var
  b: Boolean;
  function _boolToStr(Value: Boolean): string;
  begin
    Result := Ord(Value).ToString;
  end;
begin
  if _OnModify then Exit;
  Vars[SysVars[0]] := _boolToStr(CheckBox1.IsChecked);
  Vars[SysVars[1]] := _boolToStr(CheckBox2.IsChecked);
  Vars[SysVars[2]] := _boolToStr(CheckBox3.IsChecked);
  Vars[SysVars[3]] := _boolToStr(CheckBox4.IsChecked);
  Vars[SysVars[4]] := _boolToStr(CheckBox5.IsChecked);
  b := CheckBox6.IsChecked;
  Vars[SysVars[5]] := _boolToStr(b);
  CheckBox7.Enabled := b;
  CheckBox8.Enabled := b;
  if not b then
    begin
      Vars[SysVars[6]] := '0';
      Vars[SysVars[7]] := '0';
    end
  else
    begin
      b := CheckBox7.IsChecked;
      Vars[SysVars[6]] := _boolToStr(b);
      CheckBox8.Enabled := b;
      if not b then Vars[SysVars[7]] := '0'
      else Vars[SysVars[7]] := _boolToStr(CheckBox8.IsChecked);
    end;
  Vars[SysVars[8]] := _boolToStr(CheckBox9.IsChecked);
  Vars[SysVars[9]] := _boolToStr(CheckBox16.IsChecked);
  Vars[SysVars[10]] := _boolToStr(CheckBox17.IsChecked);
  Vars[SysVars[14]] := _boolToStr(CheckBox11.IsChecked);
  if RadioButton1.IsChecked then Vars[SysVars[11]] := '0'
  else if RadioButton2.IsChecked then Vars[SysVars[11]] := '1'
  else if RadioButton3.IsChecked then Vars[SysVars[11]] := '2'
  else if RadioButton4.IsChecked then Vars[SysVars[11]] := '3'
  else if RadioButton5.IsChecked then Vars[SysVars[11]] := '4'
  else if RadioButton6.IsChecked then Vars[SysVars[11]] := '5';
  Vars[SysVars[12]] := _boolToStr(CheckBox36.IsChecked);
  Vars[SysVars[13]] := _boolToStr(CheckBox13.IsChecked);
  Vars[SysVars[15]] := _boolToStr(CheckBox10.IsChecked);
  Vars[SysVars[17]] := _boolToStr(not CheckBox14.IsChecked);
  Vars[SysVars[18]] := _boolToStr(CheckBox15.IsChecked);
  Vars[SysVars[21]] := _boolToStr(CheckBox18.IsChecked);
  CheckBox19.Enabled := CheckBox18.IsChecked;
  Vars[SysVars[22]] := _boolToStr(CheckBox19.IsChecked);
  Vars[SysVars[23]] := _boolToStr(CheckBox20.IsChecked);
  CheckBox21.Enabled := CheckBox20.IsChecked;
  Vars[SysVars[24]] := _boolToStr(CheckBox21.IsChecked);
  Vars[SysVars[25]] := _boolToStr(CheckBox23.IsChecked);
  Vars[SysVars[26]] := _boolToStr(CheckBox27.IsChecked);
  Vars[SysVars[27]] := _boolToStr(CheckBox22.IsChecked);
  Vars[SysVars[28]] := _boolToStr(CheckBox25.IsChecked);
  Vars[SysVars[29]] := _boolToStr(CheckBox24.IsChecked);
  Vars[SysVars[30]] := _boolToStr(CheckBox26.IsChecked);
  Vars[SysVars[31]] := _boolToStr(CheckBox28.IsChecked);
  Vars[SysVars[32]] := _boolToStr(CheckBox29.IsChecked);
  Vars[SysVars[33]] := _boolToStr(CheckBox31.IsChecked);
  Vars[SysVars[34]] := _boolToStr(CheckBox30.IsChecked);
  Vars[SysVars[35]] := _boolToStr(CheckBox32.IsChecked);
  Vars[SysVars[36]] := _boolToStr(CheckBox33.IsChecked);
  Vars[SysVars[37]] := _boolToStr(CheckBox12.IsChecked);
  Vars[SysVars[38]] := _boolToStr(CheckBox34.IsChecked);
  Vars[SysVars[39]] := _boolToStr(CheckBox35.IsChecked);
  Vars[SysVars[40]] := _boolToStr(CheckBox37.IsChecked);
  Vars[SysVars[41]] := _boolToStr(CheckBox40.IsChecked);
  if CheckBox39.IsChecked then Vars[SysVars[42]] := Trunc(EncodeDate(Y_D, M_D, D_D)).ToString
  else Vars[SysVars[42]] := '';
  Vars[SysVars[43]] := _boolToStr(CheckBox42.IsChecked);
  _OptionsChanged := True;
end;

procedure TEccMainForm.ComboBox2Change(Sender: TObject);
begin
  SetCalendar(EncodeDate(Y_D, M_D, D_D));
end;

procedure TEccMainForm.Expander4Resized(Sender: TObject);
begin
  TExpander(Sender).Text := TExpander(Sender).Height.ToString;
end;

procedure TEccMainForm.ExpandedChanged(Sender: TObject);
var
  e: TControl;
begin
  if _OnModify then Exit;
  _OnModify := True;
  for e in VertScrollBox2.Content.Controls do
    with e as TExpander do
      begin
        IsExpanded := e = Sender;
        if IsExpanded then
          Height := Controls[ControlsCount - 1].ChildrenCount * 23 + 36
        else Height := 30;
      end;
  _OnModify := False;
end;

procedure TEccMainForm.CBGesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
begin
  if (EventInfo.GestureID = igiLongTap) then Handled := True;
  OpenRankPopup(Sender, EventInfo.Location.X, EventInfo.Location.Y);
end;

procedure TEccMainForm.CBTap(Sender: TObject; const Point: TPointF);
begin
  OpenRankPopup(Sender, Point.X, Point.Y);
end;

procedure TEccMainForm.CBMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
  p: TPointF;
begin
  if (Button = TMouseButton(1)) or (Sender.ClassType = TLabel) then
    begin
      p := TControl(Sender).LocalToAbsolute(p);
      OpenRankPopup(Sender, X, p.Y);
    end;
end;

procedure TEccMainForm.OpenRankPopup(Sender: TObject; X, Y: Single);
begin
  if Sender.ClassType = TCheckBox then Sender := TCheckBox(Sender).TagObject;
  CurrentChanging := TMemory(TLabel(Sender).TagObject);
  PopupMenu1.Popup(X, Y);
end;

procedure TEccMainForm.CalendarChange(Sender: TObject);
var
  Y, M, D: Integer;
  yy, mm, dd: Word;
begin
  if _OnModify then Exit;
  if not (Sender = nil) then
    begin
      if Sender.ClassType = TSpeedButton then
        with Sender as TSpeedButton do
          begin
            DecodeDate(Tag, yy, mm, dd);
            Y := yy;
            M := mm;
            D := dd;
            if EccMainForm.ComboBox2.ItemIndex = 0 then
              CalendarConvert(Y, M, D, True);
          end
      else
        begin
          Y := Trunc(SpinBox1.Value);
          M := ComboBox1.ItemIndex + 1;
          D := Label1.Text.ToInteger;
        end;
      if D > MonthDays[IsLeap(Y, ComboBox2.ItemIndex = 0)][M] then
        D := MonthDays[IsLeap(Y, ComboBox2.ItemIndex = 0)][M];
      if ComboBox2.ItemIndex = 0 then CalendarConvert(Y, M, D, False);
      SetCalendar(EncodeDate(Y, M, D));
    end;
  _OptionsChanged := True;
end;

procedure TEccMainForm.FormCreate(Sender: TObject);
begin
  OutMessage := procedure(const Text: string)
    begin
      {$IFDEF DEBUG}
      DebugWrite(Text);
      {$ENDIF}
      MessageDlg(Text, TMsgDlgType.mtError, [TMsgDlgBtn.mbOK], 0);
    end;
  RequestVariants := Request;
end;

procedure TEccMainForm.FormShow(Sender: TObject);
begin
  InitControlsArrays;
  MultiView1.Mode := TMultiViewMode.Drawer;
  XmlCode := TXmlDocument.Create(Owner);
  for var s in _LoadStart do LoadDics(s);
  LoadAdminTree;
  Path := Vars[SysVars[16]];
  AssignControls;
  IndexProc := AddBlockIndex;
  WebBrowser1 := TWebBrowser.Create(Self);
  TabItem2.AddObject(WebBrowser1);
  WebBrowser1.Align := TAlignLayout.Client;
  _OnModify := False;
  Expander8.IsExpanded := True;
  CreateOctoih;
  if Vars[SysVars[42]] <> '' then
    SetCalendar(Vars[SysVars[42]].ToInteger)
  else
    SetCalendar(Date);
  if Vars[SysVars[43]] = '1' then BrowserShow
  else
    begin
      MasterButtonClick(nil);
      MultiView1.ShowMaster;
    end;
end;

procedure TEccMainForm.LoadAdminTree;
  procedure _recurse(Node: TAdminNode; TVNode: TFmxObject);
  var
    ti: TTreeViewItem;
  begin
    for var i := 0 to Node.Childs.Count - 1 do
      begin
        ti := TTreeViewItem.Create(TreeView1);
        ti.TagObject := Node.Childs[i];
        ti.Text := Node.Childs[i].Title;
        TVNode.AddObject(ti);
        _recurse(Node.Childs[i], ti);
      end;
  end;
begin
  TreeView1.Clear;
  _recurse(AdminDiv, TreeView1);
end;

procedure TEccMainForm.AddBlockIndex(const Name: string; Level, Id: Integer);
var
  p: TLabel;
begin
  if Name = '' then Exit;
  p := TLabel.Create(VertScrollBox3);
  p.Align := TAlignLayout.Top;
  p.Position.Y := MaxLongInt;
  p.TextSettings.Trimming := TTextTrimming.None;
  p.WordWrap := False;
  VertScrollBox3.AddObject(p);
  p.Text := Name.Replace('[B:', '').Replace(']', '');
  if p.Text.Chars[p.Text.Length - 1] = '.' then p.Text := p.Text.Remove(p.Text.Length - 1);
  p.Font.Family := 'Orthodox.tt ieUcs8';
  case Level of
    1..3: p.Font.Size := 30;
    4..5: p.Font.Size := 24;
    else p.Font.Size := 18;
  end;
  p.Height := p.Font.Size * 1.25;
  case Level of
    1: p.FontColor := TAlphaColorRec.Aqua;
    2: p.FontColor := TAlphaColorRec.White;
    3: p.FontColor := TAlphaColorRec.Red;
    4: p.FontColor := $ffdf7f7f;
    5..6: p.FontColor := TAlphaColorRec.Silver;
  end;
  p.HitTest := True;
  p.Margins.Top := -4;
  p.Margins.Left := (Level - 1) * 20;
  p.Tag := Id;
  p.StyledSettings := [];
  p.OnClick := BlockIndexClick;
  p.OnTap := BlockIndexTap;
end;

procedure TEccMainForm.MasterButtonClick(Sender: TObject);
begin
  MultiView1.Width := ClientWidth * 0.7;
  TabItem6.Visible := False;
  TabItem1.Visible := True;
  TabItem3.Visible := True;
  TabItem4.Visible := True;
  TabControl1.ActiveTab := TabItem3;
  AnchorGo := -1;
  Switch;
end;

procedure TEccMainForm.MasterButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single);
begin
  MasterButtonClick(Sender);
end;

procedure TEccMainForm.MasterButtonTap(Sender: TObject; const Point: TPointF);
begin
  MasterButtonClick(Sender);
end;

procedure TEccMainForm.RankMenuItemTap(Sender: TObject; const Point: TPointF);
begin
  RankMenuItemClick(Sender);
end;

procedure TEccMainForm.RankMenuItemClick(Sender: TObject);
begin
  CurrentChanging.Rank := TMenuItem(Sender).Index - 1;
  ComboBox2Change(nil);
  _OptionsChanged := True;
end;

procedure TEccMainForm.MultiView1Hidden(Sender: TObject);
begin
  TabControl2.ActiveTab := TabItem2;
  if _OptionsChanged and (AResult >= 0) then BrowserShow;
  if AnchorGo > -1 then
    WebBrowser1.EvaluateJavascript('document.location.href=''#z' + AnchorGo.ToString + ''';');
end;

procedure TEccMainForm.BlockIndexClick(Sender: TObject);
begin
  MultiView1.HideMaster;
  AnchorGo := TFmxObject(Sender).Tag;
end;

procedure TEccMainForm.BlockIndexTap(Sender: TObject; const Point: TPointF);
begin
  BlockIndexClick(Sender);
end;

procedure TEccMainForm.BrowserShow;
var
  Params: TStringDynArray;
begin
  _OptionsChanged := False;
  AdjustSysVars;
  PrayList.Clear;
  while VertScrollBox3.Controls[VertScrollBox3.ControlsCount - 1].ControlsCount > 0 do
    VertScrollBox3.Controls[VertScrollBox3.ControlsCount - 1].Controls[0].Free;
  if AResult < 0 then Exit;
  LoadServices;
  ProcessChild(AssemDic[AResult.ToString], Params, PrayList);
  WebBrowser1.LoadFromStrings(GenerateHtml, '');
end;

procedure TEccMainForm.ToolBarLabelDblClick(Sender: TObject);
begin
  FullScreen := not FullScreen;
  if FullScreen then Left := 0;
end;

procedure TEccMainForm.ToolBarLabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single);
begin
  {$IFDEF MSWINDOWS}
  if (Button = TMouseButton.mbLeft) and not FullScreen then
  begin
    ReleaseCapture;
    SendMessage(FmxHandleToHWND(Self.Handle), $112, $f012, 0);
  end;
  {$ENDIF}
end;

procedure TEccMainForm.TreeView1Change(Sender: TObject);
begin
  AdjustPlaceVars(TTreeViewItem(TreeView1.Selected));
  _OptionsChanged := True;
end;

procedure TEccMainForm.UncheckRequest(Sender: TObject);
var
  p: TPair<string, string>;
begin
  with Sender as TCheckBox do
    begin
      if Parent.Children.Count >= Index then
        TControl(Parent.Children[Index + 1]).Margins.Top := Margins.Top;
      if not IsChecked then
        for p in RqVars do
          if p.Value = Text then
            begin
              Vars.Remove(p.Key);
              RqVars.Remove(p.Key);
              DeleteVar(p.Key);
              Parent.RemoveObject(TControl(Sender));
            end;
    end;
  ExpandedChanged(Expander9);
end;

procedure TEccMainForm.InitControlsArrays;
var
  i: Integer;
  b: TSpeedButton;
  l: TLabel;
const
  bw = 36;
  bh = 32;
begin
  Expds[1] := Expander3;
  Expds[2] := Expander4;
  Expds[3] := Expander5;
  Expds[4] := Expander6;
  Expds[5] := Expander7;
  for i := 1 to 6 do
    begin
      l := TLabel.Create(Self);
      l.Height := 24;
      l.Width := 120;
      l.Position.Y := (i - 1) * bh + 74;
      l.Position.X := 268;
      l.Font.Size := 17;
      l.Anchors := [TAnchorKind.akLeft, TAnchorKind.akTop, TAnchorKind.akRight];
      l.StyledSettings := [TStyledSetting.Family, TStyledSetting.Style];
      WeekLab[i] := l;
      Panel2.AddObject(l);
    end;
  for i := 1 to 42 do
    begin
      b := TSpeedButton.Create(Self);
      b.Height := bh;
      b.Width := bw;
      b.Position.Y := (i - 1) div 7 * bh + 70;
      b.Position.X := (i - 1) mod 7 * bw + 4;
      b.Tag := i;
      b.StyledSettings := [TStyledSetting.Family];
      b.OnClick := CalendarChange;
      CalendButtons[i] := b;
      Panel2.AddObject(b);
    end;
end;

procedure TEccMainForm.SpeedButton1Click(Sender: TObject);
begin
  try
    for var a in SysVars do StoreVar(a, Vars[a]);
  finally
    Close;
  end;
end;

procedure TEccMainForm.SpeedButton1Tap(Sender: TObject; const Point: TPointF);
begin
  SpeedButton1Click(Sender);
end;

procedure TEccMainForm.Switch;
var
  i: TBitmap;
begin
  i := WebBrowser1.MakeScreenshot;
  Image1.Height := i.Height;
  Image1.Width := i.Width;
  Image1.Bitmap := i;
  i.Free;
  TabControl2.ActiveTab := TabItem5;
end;

procedure TEccMainForm.SpeedButton2Click(Sender: TObject);
begin
  MultiView1.Width := ClientWidth * 0.7;
  TabItem6.Visible := True;
  TabItem1.Visible := False;
  TabItem3.Visible := False;
  TabItem4.Visible := False;
  TabControl1.ActiveTab := TabItem6;
  Switch;
  MultiView1.ShowMaster;
end;

procedure TEccMainForm.SpeedButton2Tap(Sender: TObject; const Point: TPointF);
begin
  SpeedButton2Click(Sender);
end;

procedure TEccMainForm.SpinBox1Change(Sender: TObject);
begin
  if _OnModify then Exit;
{  ArrangeMemories(Trunc(SpinBox1.Value));}
  CalendarChange(Sender);
end;

procedure TEccMainForm.SelectMemory(Sender: TObject);
begin
  if Assigned(Sender) then
    TMemExemplar(TFmxObject(TFmxObject(Sender).TagObject).TagObject).Active := TCheckBox(Sender).IsChecked;
  AResult := CalcAssembly;
  _OptionsChanged := True;
  if AResult < 0 then
    begin
      Memo1.Text := AResult.ToString + ': ' + ErrorsList[-AResult];
      Memo1.FontColor := $ffff7f7f;
    end
  else
    begin
      Memo1.Text := AResult.ToString + ': ' + AssemsList[AResult];
      Memo1.FontColor := $ff7fff7f;
    end
end;

end.
